# -*- coding: utf-8 -*-
# =-
# Copyright Solocal Group (2015)
#
# eureka@solocal.com
#
# This software is a computer program whose purpose is to provide a full
# featured participative innovation solution within your organization.
#
# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".
#
# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.
#
# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.
#
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.
# =-

from time import sleep
from nagare import i18n


class LocaleChangeEvent:
    """Answer returned when a locale is changed"""

    def __init__(self, locale):
        self.locale = locale


class LocaleChoice(object):

    @property
    def language(self):
        return i18n.get_locale().language

    @language.setter
    def language(self, language):
        locale_info = (language, None)
        locale_dir = i18n.get_locale().dirname
        domain = i18n.get_locale().domain
        i18n.set_locale(i18n.Locale(*locale_info, domain=domain, dirname=locale_dir))

    def change_locale(self, language, comp):

        self.language = language
        comp.answer(LocaleChangeEvent(language))
